diff --git a/CHANGELOG.md b/CHANGELOG.md
index 2138c580..9f2a2742 100644
--- a/CHANGELOG.md
+++ b/CHANGELOG.md
@@ -23,6 +23,7 @@ All notable changes to this project will be documented in this file. This change
 - Use Number.isInteger if possible ([#799](https://github.com/planck-repl/planck/issues/799))
 - Monkey patch target-specific array? and find-ns-obj ([#798](https://github.com/planck-repl/planck/issues/798))
 - Update `test.check` to 0.10.0-alpha3 ([#802](https://github.com/planck-repl/planck/issues/802))
+- Re-enable FTL JIT on macOS ([#820](https://github.com/planck-repl/planck/issues/820))
 
 ### Fixed
 - Cache behavior when executing standalone script with shebang deps ([#749](https://github.com/mfikes/planck/issues/749))
diff --git a/planck-c/main.c b/planck-c/main.c
index 59e08d0d..246429a1 100644
--- a/planck-c/main.c
+++ b/planck-c/main.c
@@ -9,6 +9,10 @@
 #include <signal.h>
 #include <sys/stat.h>
 
+#ifdef __APPLE__
+#include <mach-o/dyld.h>
+#endif
+
 #include "bundle.h"
 #include "engine.h"
 #include "globals.h"
@@ -315,10 +319,18 @@ bool should_ignore_arg(const char *opt) {
 
 void control_FTL_JIT() {
 
-    // Recent versions of JavaScriptCore are crashing in FTL JIT.
-    // Disable FTL JIT if JSC_useFTLJIT env var not set.
+    // Older versions of JavaScriptCore were crashing in FTL JIT.
+    // Disable FTL JIT if older version on macOS or on Unix and
+    // JSC_useFTLJIT env var not set.
+
+#ifdef __APPLE__
+    int32_t jsc_version = NSVersionOfLinkTimeLibrary("JavaScriptCore");
+    bool check_env = (jsc_version < 0x25d0308);
+#else
+    bool check_env = true;
+#endif
 
-    if (getenv("JSC_useFTLJIT") == NULL) {
+    if (check_env && getenv("JSC_useFTLJIT") == NULL) {
         putenv("JSC_useFTLJIT=false");
     }
 
